abstract class Figure{
    public area: number = 0;
    public figure: string = "figure";
    public abstract calculateArea(): void;
}

class Rectangle extends Figure{
    public height: number;
    public lenght: number;
    public override figure: string = "Rectangle";

    constructor(height: number, lenght: number){
        super();
        this.height = height;
        this.lenght = lenght;
    }
    public override calculateArea(): void {
        this.area = this.height * this.lenght;
    }
    
}
class Triangle extends Figure{
    public height: number;
    public baseline: number;
    public override figure: string = "Triangle";

    constructor(height: number, baseline: number){
        super();
        this.height = height;
        this.baseline = baseline;
    }
    public override calculateArea(): void {
        this.area = (this.height * this.baseline) / 2;
    }
    
}
class Cerlce extends Figure{
    public radius: number;
    public override figure: string = "Cercle";

    constructor(radius: number){
        super();
        this.radius = radius;
    }
    public override calculateArea(): void {
        this.area = Math.PI * Math.sqrt(this.radius);
    }
    
}

const Figures = [new Rectangle(20, 30),
new Triangle(40, 60),
new Cerlce(40)]


const printFigures = (arr: Figure[]) => {
    arr.forEach(figure => {
        figure.calculateArea();
        console.log(`Area of ${figure.figure} :`, figure.area);
    });
}
printFigures(Figures);
